﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.5
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private TrackMap As Map
	Private TrackCount As Int = 0
	Private MasterTrack As MidiTrack
	Private MasterTrackEvents As List = Array As Int(0x02,0x06,0x07,0x51,0x58,0x59)
	Private TrackNameEvent As Int = 0x03
	Private TrackNameFound As Boolean
End Sub


Public Sub ConvertToType1(Seq As MidiSequence) As MidiSequence
	
	TrackMap.Initialize


	Dim NewSeq As MidiSequence
	NewSeq.Initialize
	NewSeq.Create(Seq.GetDivisionType,Seq.GetResolution)
	
	MasterTrack = NewSeq.CreateTrack
	TrackCount = TrackCount + 1
	
	Dim OrigTrack As MidiTrack = Seq.GetTracks(0)
	
	For i = 0 To OrigTrack.Size - 1
		Dim Evt As MidiEvent = OrigTrack.Get(i)
		AddToTrack(Seq,NewSeq,Evt)
	Next
	
	Return NewSeq
End Sub

Public Sub AddToTrack(Seq As MidiSequence,NewSeq As MidiSequence,Evt As MidiEvent)
	Dim Track As MidiTrack
	Dim NewEvt As MidiEvent
	NewEvt.Initialize
	Dim CHnl As Int
	
	 
	If Evt.GetMessage.IsShortMessage Then
		CHnl = Evt.GetMessage.AsShortMessage.GetChannel
		If TrackMap.ContainsKey(CHnl) Then
			Track = NewSeq.GetTracks(TrackMap.Get(CHnl))
		Else
			Track = NewSeq.CreateTrack
			TrackMap.Put(CHnl,TrackCount)
			TrackCount = TrackCount + 1
		End If
			
	Else If Evt.GetMessage.IsMidiMetaMessage Then
		
		If AddToMasterTrack(Evt) Then
			Track = MasterTrack
		Else
		
			CHnl = Bit.And(Evt.GetMessage.AsMidiMetaMessage.GetStatus,0x0F)
			If TrackMap.ContainsKey(CHnl) Then
				Track = NewSeq.GetTracks(TrackMap.Get(CHnl))
			Else
				Track = NewSeq.CreateTrack
				TrackMap.Put(CHnl,TrackCount)
			TrackCount = TrackCount + 1
			End If
		End If
	Else If Evt.GetMessage.IsSysexMessage Then
		Track = MasterTrack
	Else
		Log("Unknown Message Type Found " & Evt.ToString("UTF8"))
		Return
	End If

	NewEvt = CloneEvent(Evt)
	
	Track.Add(NewEvt)
End Sub

Private Sub CloneEvent(Evt As MidiEvent) As MidiEvent
	
	Dim NewEvt As MidiEvent
	NewEvt.Initialize
	
	If Evt.GetMessage.IsShortMessage Then
		Dim NewShort As MidiShortMessage
		NewShort.Initialize
		NewShort.SetObject(Evt.GetMessage.Clone)
		NewEvt.CreateShort(NewShort,Evt.GetTick)
	Else If Evt.GetMessage.IsMidiMetaMessage Then
		Dim NewMeta As MidiMetaMessage
		NewMeta.Initialize
		NewMeta.SetObject(Evt.GetMessage.Clone)
		NewEvt.CreateMeta(NewMeta,Evt.GetTick)
	Else If Evt.GetMessage.IsSysexMessage Then
		Dim NewSysex As MidiSysexMessage
		NewSysex.Initialize
		NewSysex.SetObject(Evt.GetMessage.Clone)
		NewEvt.CreateSysex(NewSysex,Evt.GetTick)
	End If
	
	Return NewEvt
	
End Sub

Private Sub AddToMasterTrack(Evt As MidiEvent) As Boolean
	Dim msgType As Int = Evt.GetMessage.AsMidiMetaMessage.GetType_
	'In the midi spec the first trackname event on the first track is presumed to be the name of the work
	'subsequent trackname events are the name of the track
	If msgType = TrackNameEvent And TrackNameFound = False Then 
		TrackNameFound = True
		Return True
	End If
	Return MasterTrackEvents.IndexOf(msgType) > -1
End Sub